<template>
<div>
  <h1 class="form-title">Create Project In GitLab</h1>
  <el-form-item label="Gitlab Instance :" prop="gitlab_url" >
    <el-select
    :disabled="createProjectBool"
      v-model="project_model.gitlab_url"
      placeholder="Select GitLab Instance"
    >
      <el-option
        v-for="item in Instances"
        :key="item.value"
        :label="item.label"
        :value="item.value"
      >
      </el-option>
    </el-select>

  </el-form-item>
  <el-form-item label="Repo-Name:" prop="repo_name">
    <el-input v-model="project_model.repo_name" ></el-input>
  </el-form-item>
  <el-form-item>
    <el-button type="primary"   @click="createProjectfunc"
      >Create Project</el-button
    >
  </el-form-item>
  <el-row :gutter="20">
    <el-col :span="20">
      <el-form-item label="Add Developer to Repo: " prop="approvers">
        <el-select
          v-model="project_model.devtobeadded"
          type="textarea"
          multiple
          filterable
          remote
          :disabled="addDevBool"
          :remote-method="remoteMethodDev"
          :loading="loading"
        >
          <el-option
            v-for="item in devoptions"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
    </el-col>

    <el-form-item>
      <el-button type="primary" @click="addDevloper" :disabled="addDevBool" >Add</el-button>
    </el-form-item>
  </el-row>
  <div>
  <el-row :gutter="20">
    <el-col :span="20">
      <el-form-item label="Repo-Url:" prop="repo_url">
        <el-input v-model="model.repo_url" disabled></el-input>
      </el-form-item>
    </el-col>
  </el-row>
  <el-form-item label="Repo-Name:" prop="repo_name">
    <el-input v-model="model.repo_name" disabled></el-input>
  </el-form-item>
  <el-form-item label="Repo-Id: " prop="repo_id">
    <el-input v-model="model.repo_id" disabled></el-input>
  </el-form-item>
  <el-form-item label="No. of Approvers: " prop="no_of_approvers">
    <el-input v-model.number="model.no_of_approvers"></el-input>
  </el-form-item>
  <el-row :gutter="20">
    <el-col :span="20">
      <el-form-item label="Search for Username: " prop="approvers">
        <el-select
          v-model="value"
          type="textarea"
          multiple
          filterable
          remote
          :remote-method="remoteMethod"
          :disabled="!model.repo_id"
          :loading="loading"
        >
          <el-option
            v-for="item in options"
            :key="item.id"
            :label="item.name"
            :value="item.username"
          />
        </el-select>
      </el-form-item>
    </el-col>

    <el-form-item>
      <el-button type="primary" @click="addApproversIdToFormData"
        >Add</el-button
      >
    </el-form-item>
  </el-row>
  <el-form-item label="Already added Approvers">
    <el-tag
      v-for="tag in tags"
      :key="tag.index"
      closable
      @close="handleCloseTag(tag)"
    >
      {{ tag }}
    </el-tag>
  </el-form-item>
  </div>
  <!-- {{ project_model }} -->
</div>
</template>
<script>
import { mapState } from "vuex";

export default {
name: "CreateRepoPopup",
props: ["apiParams"],
data() {
  return {
    createProjectBool : false,
    addDevBool : true,
    devoptions: [],
    
    Instances: [
      {
        value: "https://gitlab.com",
        label: "gitlab.com",
      }
    ],
    loading: false,
    project_model: {
      gitlab_url: "",
      repo_name: "",
      devtobeadded : [],
      project_id: undefined,
    },
    options: [],
    value: [],
    tags: [],
    model: {
      repo_url: "",
      repo_name: "",
      repo_id: undefined,
      no_of_approvers: "",
      approvers: [],
    },
  };
},
computed: {
  ...mapState({
    emails: (state) => state.repository.emails,
  }),
  rules() {
    return {
      no_of_approvers: [
        {
          required: true,
          message: "Please input no of approvers",
          trigger: "change",
        },
        { type: "number", message: "No of approvers must be a number" },
      ],
      approvers :[
        {
          required: true,
          message: "Please Click on add button",
          trigger: "change",
        }
      ]
    };
  },
},
methods: {
  async createProjectfunc() {
    this.createProjectBool = true
    // console.log(".then k phle")
    let data = await this.$store.dispatch("createProject", this.project_model)
    // console.log("after .then", data)
    this.model.repo_url = data.web_url
    this.model.repo_name = data.name
    this.model.repo_id = data.id
    this.project_model.project_id = data.id
    this.addDevBool = false
  },

  handleCloseTag(tag) {
    this.model.approvers.splice(this.model.approvers.indexOf(tag), 1);
    this.tags.splice(this.tags.indexOf(tag), 1);
  },
  remoteMethod(query) {
    let fullurl = new URL(this.model.repo_url);
    let baseurl = fullurl.origin;
    if (query !== "") {
      this.loading = true;
      const config = {
        method: "post",
        url: '/search-user',
        data: {
          requrl: baseurl,
          query: query,
        },
      };
      this.$axios(config)
        .then((res) => {
          this.options = res.data;
          this.loading = false;
        })
        .catch((err) => {
          console.log(err);
        });
    }
  },
  remoteMethodDev(query) {
    let baseurl = this.project_model.gitlab_url;
    // console.log(baseurl)
    if (query !== "") {
      this.loading = true;
      const config = {
        method: "post",
        url: '/search-user',
        data: {
          requrl: baseurl,
          query: query,
        },
      };
      this.$axios(config)
        .then((res) => {
          this.devoptions = res.data;
          this.loading = false;
        })
        .catch((err) => {
          console.log(err);
        });
    }
  },
  addApproversIdToFormData() {
    let newarr = this.model.approvers;
    let tagarr = this.tags;
    this.value.forEach(async (approver) => {
      let payload = {
        url: `items/approvers?&filter[email]=${approver}`,
      };
      await this.$store.dispatch("getField", payload).then((resdata) => {
        if (resdata.length > 0 && resdata[0].email == approver) {
          // console.log("res data here in if", resdata);
          let obj = {};
          obj["approvers_approvers_id"] = resdata[0].approvers_id;
          // console.log("obj", obj);
          tagarr.push(approver);
          newarr.push(obj);
        } else {
          // console.log("im in else", resdata);
          let obj = {};
          obj["email"] = approver;
          let finalobj = {};
          finalobj["approvers_approvers_id"] = obj;
          tagarr.push(approver);
          newarr.push(finalobj);
        }
      });
      this.model.approvers = newarr;
      this.tags = tagarr;
      this.value = []
    });
  },
  addDevloper(){
    this.$store.dispatch("addDevloper",this.project_model)
    this.addDevBool = true
  },
  postData() {
    this.apiParams["data"] = this.model;
    this.$store.dispatch("setWebHook",this.model)
    this.$store.dispatch("protectBranch",this.model)
    return this.$store.dispatch("createTableData", this.apiParams);
  },
},
};
</script>